'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _lodash = require('lodash.topath');

var _lodash2 = _interopRequireDefault(_lodash);

var _ramda = require('ramda');

var r = _interopRequireWildcard(_ramda);

var _paths = require('./paths');

var _paths2 = _interopRequireDefault(_paths);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var edgeToTransformation = function edgeToTransformation(_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      fRawPath = _ref2[0],
      depRawPaths = _ref2[1];

  var fPath = (0, _lodash2.default)(fRawPath);
  var depPaths = r.map(_lodash2.default, depRawPaths);
  var fLens = r.lensPath(fPath);

  return function (graph) {
    return r.over(fLens, function (f) {
      return r.partial(f, (0, _paths2.default)(depPaths, graph));
    }, graph);
  };
};

var mapEdgesToTransformations = r.map(edgeToTransformation);

exports.default = function (edges, graph) {
  var transformations = mapEdgesToTransformations(edges);

  return r.pipe.apply(null, transformations)(graph);
};